diff --git a/gdbserver/linux-low.c b/gdbserver/linux-low.c
index 17f360639a4..fd122535cc5 100644
--- a/gdbserver/linux-low.c
+++ b/gdbserver/linux-low.c
@@ -996,9 +996,9 @@ linux_ptrace_fun ()
    PROGRAM is the name of the program to be started, and PROGRAM_ARGS
    are its arguments.  */
 
-static int
-linux_create_inferior (const char *program,
-		       const std::vector<char *> &program_args)
+int
+linux_process_target::create_inferior (
+    const char *program, const std::vector<char *> &program_args)
 {
   client_state &cs = get_client_state ();
   struct lwp_info *new_lwp;
@@ -7359,7 +7359,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_create_inferior,
   linux_post_create_inferior,
   linux_attach,
   linux_kill,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index f17ac95fae8..acaca0c0070 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -269,6 +269,8 @@ extern struct linux_target_ops the_low_target;
 class linux_process_target : public process_target {
 public:
 
+  int create_inferior (const char *program,
+		       const std::vector<char *> &program_args) override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.c b/gdbserver/lynx-low.c
index f1177920921..61b56739e36 100644
--- a/gdbserver/lynx-low.c
+++ b/gdbserver/lynx-low.c
@@ -248,9 +248,9 @@ lynx_ptrace_fun ()
 
 /* Implement the create_inferior method of the target_ops vector.  */
 
-static int
-lynx_create_inferior (const char *program,
-		      const std::vector<char *> &program_args)
+int
+lynx_process_target::create_inferior (
+    const char *program, const std::vector<char *> &program_args)
 {
   int pid;
   std::string str_program_args = stringify_argv (program_args);
@@ -726,7 +726,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  lynx_create_inferior,
   NULL,  /* post_create_inferior */
   lynx_attach,
   lynx_kill,
diff --git a/gdbserver/lynx-low.h b/gdbserver/lynx-low.h
index ca9601b221b..e74d80be5b4 100644
--- a/gdbserver/lynx-low.h
+++ b/gdbserver/lynx-low.h
@@ -57,6 +57,8 @@ extern struct lynx_target_ops the_low_target;
 class lynx_process_target : public process_target {
 public:
 
+  int create_inferior (const char *program,
+		       const std::vector<char *> &program_args) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/nto-low.c b/gdbserver/nto-low.c
index 6f12a735c12..e5df5b3e9db 100644
--- a/gdbserver/nto-low.c
+++ b/gdbserver/nto-low.c
@@ -350,9 +350,9 @@ nto_read_auxv_from_initial_stack (CORE_ADDR initial_stack,
 /* Start inferior specified by PROGRAM, using PROGRAM_ARGS as its
    arguments.  */
 
-static int
-nto_create_inferior (const char *program,
-		     const std::vector<char *> &program_args)
+int
+nto_process_target::create_inferior (
+    const char *program, const std::vector<char *> &program_args)
 {
   struct inheritance inherit;
   pid_t pid;
@@ -935,7 +935,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  nto_create_inferior,
   NULL,  /* post_create_inferior */
   nto_attach,
   nto_kill,
diff --git a/gdbserver/nto-low.h b/gdbserver/nto-low.h
index 398382113b6..cc028d7e07d 100644
--- a/gdbserver/nto-low.h
+++ b/gdbserver/nto-low.h
@@ -47,6 +47,8 @@ extern struct nto_target_ops the_low_target;
 class nto_process_target : public process_target {
 public:
 
+  int create_inferior (const char *program,
+		       const std::vector<char *> &program_args) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/server.c b/gdbserver/server.c
index 3fc026f78eb..73f8e185477 100644
--- a/gdbserver/server.c
+++ b/gdbserver/server.c
@@ -3028,7 +3028,7 @@ handle_v_run (char *own_buf)
   free_vector_argv (program_args);
   program_args = new_argv;
 
-  create_inferior (program_path.get (), program_args);
+  target_create_inferior (program_path.get (), program_args);
 
   if (cs.last_status.kind == TARGET_WAITKIND_STOPPED)
     {
@@ -3784,7 +3784,7 @@ captured_main (int argc, char *argv[])
       program_args.push_back (NULL);
 
       /* Wait till we are at first instruction in program.  */
-      create_inferior (program_path.get (), program_args);
+      target_create_inferior (program_path.get (), program_args);
 
       /* We are now (hopefully) stopped at the first instruction of
 	 the target process.  This assumes that the target process was
@@ -4303,7 +4303,7 @@ process_serial_event (void)
 	  /* Wait till we are at 1st instruction in prog.  */
 	  if (program_path.get () != NULL)
 	    {
-	      create_inferior (program_path.get (), program_args);
+	      target_create_inferior (program_path.get (), program_args);
 
 	      if (cs.last_status.kind == TARGET_WAITKIND_STOPPED)
 		{
diff --git a/gdbserver/target.h b/gdbserver/target.h
index af3995425a3..7caf096b111 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,17 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Start a new process.
-
-     PROGRAM is a path to the program to execute.
-     PROGRAM_ARGS is a standard NULL-terminated array of arguments,
-     to be passed to the inferior as ``argv'' (along with PROGRAM).
-
-     Returns the new PID on success, -1 on failure.  Registers the new
-     process with the process list.  */
-  int (*create_inferior) (const char *program,
-			  const std::vector<char *> &program_args);
-
   /* Do additional setup after a new process is created, including
      exec-wrapper completion.  */
   void (*post_create_inferior) (void);
@@ -488,14 +477,25 @@ class process_target {
 public:
 
   virtual ~process_target () = default;
+
+  /* Start a new process.
+
+     PROGRAM is a path to the program to execute.
+     PROGRAM_ARGS is a standard NULL-terminated array of arguments,
+     to be passed to the inferior as ``argv'' (along with PROGRAM).
+
+     Returns the new PID on success, -1 on failure.  Registers the new
+     process with the process list.  */
+  virtual int create_inferior
+      (const char *program, const std::vector<char *> &program_args) = 0;
 };
 
 extern process_stratum_target *the_target;
 
 void set_target_ops (process_stratum_target *);
 
-#define create_inferior(program, program_args)	\
-  (*the_target->create_inferior) (program, program_args)
+#define target_create_inferior(program, program_args)	\
+  the_target->pt->create_inferior (program, program_args)
 
 #define target_post_create_inferior()			 \
   do							 \
diff --git a/gdbserver/win32-low.c b/gdbserver/win32-low.c
index b0b54a10669..2e1028b9a8d 100644
--- a/gdbserver/win32-low.c
+++ b/gdbserver/win32-low.c
@@ -625,9 +625,9 @@ Could not convert the expanded inferior cwd to wide-char."));
    PROGRAM_ARGS is the vector containing the inferior's args.
    Returns the new PID on success, -1 on failure.  Registers the new
    process with the process list.  */
-static int
-win32_create_inferior (const char *program,
-		       const std::vector<char *> &program_args)
+int
+win32_process_target::create_inferior (
+    const char *program, const std::vector<char *> &program_args)
 {
   client_state &cs = get_client_state ();
 #ifndef USE_WIN32API
@@ -1828,7 +1828,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  win32_create_inferior,
   NULL,  /* post_create_inferior */
   win32_attach,
   win32_kill,
diff --git a/gdbserver/win32-low.h b/gdbserver/win32-low.h
index f8cc0b27c7f..661d8a385c1 100644
--- a/gdbserver/win32-low.h
+++ b/gdbserver/win32-low.h
@@ -106,6 +106,8 @@ extern struct win32_target_ops the_low_target;
 class win32_process_target : public process_target {
 public:
 
+  int create_inferior (const char *program,
+		       const std::vector<char *> &program_args) override;
 };
 
 /* Retrieve the context for this thread, if not already retrieved.  */