diff --git a/gdbserver/linux-low.c b/gdbserver/linux-low.c
index 8e62ed91a77..3298d142f26 100644
--- a/gdbserver/linux-low.c
+++ b/gdbserver/linux-low.c
@@ -1386,8 +1386,8 @@ kill_one_lwp_callback (thread_info *thread, int pid)
   kill_wait_lwp (lwp);
 }
 
-static int
-linux_kill (process_info *process)
+int
+linux_process_target::kill (process_info *process)
 {
   int pid = process->pid;
 
@@ -7359,7 +7359,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_kill,
   linux_detach,
   linux_mourn,
   linux_join,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index 673c5bbc407..636032e3212 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -275,6 +275,8 @@ public:
   void post_create_inferior () override;
 
   int attach (unsigned long pid) override;
+
+  int kill (process_info *proc) override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.c b/gdbserver/lynx-low.c
index 2e2535e1d61..fb59d5105cb 100644
--- a/gdbserver/lynx-low.c
+++ b/gdbserver/lynx-low.c
@@ -521,8 +521,8 @@ lynx_wait (ptid_t ptid, struct target_waitstatus *status, int options)
 
 /* Implement the kill target_ops method.  */
 
-static int
-lynx_kill (process_info *process)
+int
+lynx_process_target::kill (process_info *process)
 {
   ptid_t ptid = lynx_ptid_t (process->pid, 0);
   struct target_waitstatus status;
@@ -726,7 +726,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  lynx_kill,
   lynx_detach,
   lynx_mourn,
   lynx_join,
diff --git a/gdbserver/lynx-low.h b/gdbserver/lynx-low.h
index 7a3f03fb36e..749b0dee19f 100644
--- a/gdbserver/lynx-low.h
+++ b/gdbserver/lynx-low.h
@@ -61,6 +61,8 @@ public:
 		       const std::vector<char *> &program_args) override;
 
   int attach (unsigned long pid) override;
+
+  int kill (process_info *proc) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/nto-low.c b/gdbserver/nto-low.c
index 47be6eeab86..0af8fb1bcee 100644
--- a/gdbserver/nto-low.c
+++ b/gdbserver/nto-low.c
@@ -396,8 +396,8 @@ nto_process_target::attach (unsigned long pid)
 
 /* Send signal to process PID.  */
 
-static int
-nto_kill (process_info *proc)
+int
+nto_process_target::kill (process_info *proc)
 {
   int pid = proc->pid;
 
@@ -935,7 +935,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  nto_kill,
   nto_detach,
   nto_mourn,
   NULL, /* nto_join */
diff --git a/gdbserver/nto-low.h b/gdbserver/nto-low.h
index e5d2fa83135..fbef01dedc9 100644
--- a/gdbserver/nto-low.h
+++ b/gdbserver/nto-low.h
@@ -51,6 +51,8 @@ public:
 		       const std::vector<char *> &program_args) override;
 
   int attach (unsigned long pid) override;
+
+  int kill (process_info *proc) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/target.c b/gdbserver/target.c
index 81092e81ea4..a9632aa8cd9 100644
--- a/gdbserver/target.c
+++ b/gdbserver/target.c
@@ -319,7 +319,7 @@ kill_inferior (process_info *proc)
 {
   gdb_agent_about_to_close (proc->pid);
 
-  return (*the_target->kill) (proc);
+  return the_target->pt->kill (proc);
 }
 
 /* Target can do hardware single step.  */
diff --git a/gdbserver/target.h b/gdbserver/target.h
index a2bbfed5b07..a1e9de15c2a 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,10 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Kill process PROC.  Return -1 on failure, and 0 on success.  */
-
-  int (*kill) (process_info *proc);
-
   /* Detach from process PROC.  Return -1 on failure, and 0 on
      success.  */
 
@@ -487,6 +483,9 @@ public:
      Returns -1 if attaching is unsupported, 0 on success, and calls
      error() otherwise.  */
   virtual int attach (unsigned long pid) = 0;
+
+  /* Kill process PROC.  Return -1 on failure, and 0 on success.  */
+  virtual int kill (process_info *proc) = 0;
 };
 
 extern process_stratum_target *the_target;
diff --git a/gdbserver/win32-low.c b/gdbserver/win32-low.c
index 1acab18d09f..7c86080ed3b 100644
--- a/gdbserver/win32-low.c
+++ b/gdbserver/win32-low.c
@@ -808,8 +808,8 @@ win32_clear_inferiors (void)
 
 /* Implementation of target_ops::kill.  */
 
-static int
-win32_kill (process_info *process)
+int
+win32_process_target::kill (process_info *process)
 {
   TerminateProcess (current_process_handle, 0);
   for (;;)
@@ -1828,7 +1828,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  win32_kill,
   win32_detach,
   win32_mourn,
   win32_join,
diff --git a/gdbserver/win32-low.h b/gdbserver/win32-low.h
index f626db6cf60..c2d5b577e98 100644
--- a/gdbserver/win32-low.h
+++ b/gdbserver/win32-low.h
@@ -110,6 +110,8 @@ public:
 		       const std::vector<char *> &program_args) override;
 
   int attach (unsigned long pid) override;
+
+  int kill (process_info *proc) override;
 };
 
 /* Retrieve the context for this thread, if not already retrieved.  */