diff --git a/gdbserver/linux-low.c b/gdbserver/linux-low.c
index ae10d5a2282..5722752fd12 100644
--- a/gdbserver/linux-low.c
+++ b/gdbserver/linux-low.c
@@ -262,7 +262,6 @@ static int stabilizing_threads;
 
 static void linux_resume_one_lwp (struct lwp_info *lwp,
 				  int step, int signal, siginfo_t *info);
-static void linux_resume (struct thread_resume *resume_info, size_t n);
 static void stop_all_lwps (int suspend, struct lwp_info *except);
 static void unstop_all_lwps (int unsuspend, struct lwp_info *except);
 static void unsuspend_all_lwps (struct lwp_info *except);
@@ -5002,8 +5001,8 @@ linux_resume_one_thread (thread_info *thread, bool leave_all_stopped)
   lwp->resume = NULL;
 }
 
-static void
-linux_resume (struct thread_resume *resume_info, size_t n)
+void
+linux_process_target::resume (thread_resume *resume_info, size_t n)
 {
   struct thread_info *need_step_over = NULL;
 
@@ -7359,7 +7358,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_resume,
   linux_wait,
   linux_fetch_registers,
   linux_store_registers,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index f3bb7826a68..48d92f73ced 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -285,6 +285,8 @@ public:
   void join (int pid) override;
 
   bool thread_alive (ptid_t pid) override;
+
+  void resume (thread_resume *resume_info, size_t n) override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.c b/gdbserver/lynx-low.c
index 99ef605f27d..b3eacd8b6c2 100644
--- a/gdbserver/lynx-low.c
+++ b/gdbserver/lynx-low.c
@@ -326,8 +326,8 @@ lynx_process_target::attach (unsigned long pid)
 
 /* Implement the resume target_ops method.  */
 
-static void
-lynx_resume (struct thread_resume *resume_info, size_t n)
+void
+lynx_process_target::resume (thread_resume *resume_info, size_t n)
 {
   ptid_t ptid = resume_info[0].thread;
   const int request
@@ -726,7 +726,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  lynx_resume,
   lynx_wait,
   lynx_fetch_registers,
   lynx_store_registers,
diff --git a/gdbserver/lynx-low.h b/gdbserver/lynx-low.h
index aa5d4b20505..6ad41545679 100644
--- a/gdbserver/lynx-low.h
+++ b/gdbserver/lynx-low.h
@@ -71,6 +71,8 @@ public:
   void join (int pid) override;
 
   bool thread_alive (ptid_t pid) override;
+
+  void resume (thread_resume *resume_info, size_t n) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/nto-low.c b/gdbserver/nto-low.c
index bd2ee687147..aba63786203 100644
--- a/gdbserver/nto-low.c
+++ b/gdbserver/nto-low.c
@@ -451,8 +451,8 @@ nto_process_target::thread_alive (ptid_t ptid)
 
 /* Resume inferior's execution.  */
 
-static void
-nto_resume (struct thread_resume *resume_info, size_t n)
+void
+nto_process_target::resume (thread_resume *resume_info, size_t n)
 {
   /* We can only work in all-stop mode.  */
   procfs_status status;
@@ -941,7 +941,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  nto_resume,
   nto_wait,
   nto_fetch_registers,
   nto_store_registers,
diff --git a/gdbserver/nto-low.h b/gdbserver/nto-low.h
index 056186e0071..b0ca4247e69 100644
--- a/gdbserver/nto-low.h
+++ b/gdbserver/nto-low.h
@@ -61,6 +61,8 @@ public:
   void join (int pid) override;
 
   bool thread_alive (ptid_t pid) override;
+
+  void resume (thread_resume *resume_info, size_t n) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/server.c b/gdbserver/server.c
index 73f8e185477..92feff36516 100644
--- a/gdbserver/server.c
+++ b/gdbserver/server.c
@@ -2847,7 +2847,7 @@ resume (struct thread_resume *actions, size_t num_actions)
       enable_async_io ();
     }
 
-  (*the_target->resume) (actions, num_actions);
+  the_target->pt->resume (actions, num_actions);
 
   if (non_stop)
     write_ok (cs.own_buf);
diff --git a/gdbserver/target.c b/gdbserver/target.c
index f6d8d927b85..eca53de982e 100644
--- a/gdbserver/target.c
+++ b/gdbserver/target.c
@@ -211,7 +211,7 @@ target_stop_and_wait (ptid_t ptid)
   resume_info.thread = ptid;
   resume_info.kind = resume_stop;
   resume_info.sig = GDB_SIGNAL_0;
-  (*the_target->resume) (&resume_info, 1);
+  the_target->pt->resume (&resume_info, 1);
 
   non_stop = true;
   mywait (ptid, &status, 0, 0);
@@ -244,7 +244,7 @@ target_continue_no_signal (ptid_t ptid)
   resume_info.thread = ptid;
   resume_info.kind = resume_continue;
   resume_info.sig = GDB_SIGNAL_0;
-  (*the_target->resume) (&resume_info, 1);
+  the_target->pt->resume (&resume_info, 1);
 }
 
 /* See target/target.h.  */
@@ -257,7 +257,7 @@ target_continue (ptid_t ptid, enum gdb_signal signal)
   resume_info.thread = ptid;
   resume_info.kind = resume_continue;
   resume_info.sig = gdb_signal_to_host (signal);
-  (*the_target->resume) (&resume_info, 1);
+  the_target->pt->resume (&resume_info, 1);
 }
 
 /* See target/target.h.  */
diff --git a/gdbserver/target.h b/gdbserver/target.h
index e2bdddcb137..0a07d7f8c85 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,10 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Resume the inferior process.  */
-
-  void (*resume) (struct thread_resume *resume_info, size_t n);
-
   /* Wait for the inferior process or thread to change state.  Store
      status through argument pointer STATUS.
 
@@ -482,6 +478,9 @@ public:
 
   /* Return true iff the thread with process ID PID is alive.  */
   virtual bool thread_alive (ptid_t pid) = 0;
+
+  /* Resume the inferior process.  */
+  virtual void resume (thread_resume *resume_info, size_t n) = 0;
 };
 
 extern process_stratum_target *the_target;
diff --git a/gdbserver/win32-low.c b/gdbserver/win32-low.c
index adf0dc4d902..fcbf3075e80 100644
--- a/gdbserver/win32-low.c
+++ b/gdbserver/win32-low.c
@@ -897,8 +897,8 @@ win32_process_target::thread_alive (ptid_t ptid)
 
 /* Resume the inferior process.  RESUME_INFO describes how we want
    to resume.  */
-static void
-win32_resume (struct thread_resume *resume_info, size_t n)
+void
+win32_process_target::resume (thread_resume *resume_info, size_t n)
 {
   DWORD tid;
   enum gdb_signal sig;
@@ -1828,7 +1828,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  win32_resume,
   win32_wait,
   win32_fetch_inferior_registers,
   win32_store_inferior_registers,
diff --git a/gdbserver/win32-low.h b/gdbserver/win32-low.h
index e73569b07b3..472be13d518 100644
--- a/gdbserver/win32-low.h
+++ b/gdbserver/win32-low.h
@@ -120,6 +120,8 @@ public:
   void join (int pid) override;
 
   bool thread_alive (ptid_t pid) override;
+
+  void resume (thread_resume *resume_info, size_t n) override;
 };
 
 /* Retrieve the context for this thread, if not already retrieved.  */