diff --git a/gdbserver/linux-low.c b/gdbserver/linux-low.c
index 89ef5ab9224..cf5192fef61 100644
--- a/gdbserver/linux-low.c
+++ b/gdbserver/linux-low.c
@@ -5911,12 +5911,12 @@ linux_process_target::look_up_symbols ()
 #endif
 }
 
-static void
-linux_request_interrupt (void)
+void
+linux_process_target::request_interrupt ()
 {
   /* Send a SIGINT to the process group.  This acts just like the user
      typed a ^C on the controlling terminal.  */
-  kill (-signal_pid, SIGINT);
+  ::kill (-signal_pid, SIGINT);
 }
 
 /* Copy LEN bytes from inferior's auxiliary vector starting at OFFSET
@@ -7369,7 +7369,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_request_interrupt,
   linux_read_auxv,
   linux_supports_z_point_type,
   linux_insert_point,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index ae9484d8211..9340c78cdd0 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -306,6 +306,8 @@ public:
 		    int len) override;
 
   void look_up_symbols () override;
+
+  void request_interrupt () override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.c b/gdbserver/lynx-low.c
index 21a03cf5d00..0687aacfe61 100644
--- a/gdbserver/lynx-low.c
+++ b/gdbserver/lynx-low.c
@@ -714,8 +714,8 @@ lynx_process_target::write_memory (CORE_ADDR memaddr,
 
 /* Implement the kill_request target_ops method.  */
 
-static void
-lynx_request_interrupt (void)
+void
+lynx_process_target::request_interrupt ()
 {
   ptid_t inferior_ptid = ptid_of (get_first_thread ());
 
@@ -729,7 +729,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  lynx_request_interrupt,
   NULL,  /* read_auxv */
   NULL,  /* supports_z_point_type */
   NULL,  /* insert_point */
diff --git a/gdbserver/lynx-low.h b/gdbserver/lynx-low.h
index 05223ec9774..3560c22abc1 100644
--- a/gdbserver/lynx-low.h
+++ b/gdbserver/lynx-low.h
@@ -86,6 +86,8 @@ public:
 
   int write_memory (CORE_ADDR memaddr, const unsigned char *myaddr,
 		    int len) override;
+
+  void request_interrupt () override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/nto-low.c b/gdbserver/nto-low.c
index fc548ff72ba..f7b08b4524f 100644
--- a/gdbserver/nto-low.c
+++ b/gdbserver/nto-low.c
@@ -746,8 +746,8 @@ nto_process_target::write_memory (CORE_ADDR memaddr,
 
 /* Stop inferior.  We always stop all threads.  */
 
-static void
-nto_request_interrupt (void)
+void
+nto_process_target::request_interrupt ()
 {
   TRACE ("%s\n", __func__);
   nto_set_thread (ptid_t (nto_inferior.pid, 1, 0));
@@ -943,7 +943,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  nto_request_interrupt,
   nto_read_auxv,
   nto_supports_z_point_type,
   nto_insert_point,
diff --git a/gdbserver/nto-low.h b/gdbserver/nto-low.h
index 6f420219ad4..1ce518189c6 100644
--- a/gdbserver/nto-low.h
+++ b/gdbserver/nto-low.h
@@ -76,6 +76,8 @@ public:
 
   int write_memory (CORE_ADDR memaddr, const unsigned char *myaddr,
 		    int len) override;
+
+  void request_interrupt () override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/remote-utils.c b/gdbserver/remote-utils.c
index b8a8c6576f9..b5248ab368e 100644
--- a/gdbserver/remote-utils.c
+++ b/gdbserver/remote-utils.c
@@ -710,7 +710,7 @@ putpkt_binary_1 (char *buf, int cnt, int is_notif)
 
       /* Check for an input interrupt while we're here.  */
       if (cc == '\003' && current_thread != NULL)
-	(*the_target->request_interrupt) ();
+	the_target->pt->request_interrupt ();
     }
   while (cc != '+');
 
@@ -779,7 +779,7 @@ input_interrupt (int unused)
 	  return;
 	}
 
-      (*the_target->request_interrupt) ();
+      the_target->pt->request_interrupt ();
     }
 }
 
@@ -986,7 +986,7 @@ getpkt (char *buf)
 	     check for an input interrupt.  */
 	  if (c == '\003')
 	    {
-	      (*the_target->request_interrupt) ();
+	      the_target->pt->request_interrupt ();
 	      continue;
 	    }
 
@@ -1076,7 +1076,7 @@ getpkt (char *buf)
     {
       /* Consume the interrupt character in the buffer.  */
       readchar ();
-      (*the_target->request_interrupt) ();
+      the_target->pt->request_interrupt ();
     }
 
   return bp - buf;
diff --git a/gdbserver/server.c b/gdbserver/server.c
index 4785eabaf06..bc497f87b7f 100644
--- a/gdbserver/server.c
+++ b/gdbserver/server.c
@@ -3088,7 +3088,7 @@ handle_v_requests (char *own_buf, int packet_len, int *new_packet_len)
     {
       if (strcmp (own_buf, "vCtrlC") == 0)
 	{
-	  (*the_target->request_interrupt) ();
+	  the_target->pt->request_interrupt ();
 	  write_ok (own_buf);
 	  return;
 	}
diff --git a/gdbserver/target.h b/gdbserver/target.h
index 73343bd0c03..1eb5657045c 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,11 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Send an interrupt request to the inferior process,
-     however is appropriate.  */
-
-  void (*request_interrupt) (void);
-
   /* Read auxiliary vector data from the inferior process.
 
      Read LEN bytes at OFFSET into a buffer at MYADDR.  */
@@ -475,6 +470,10 @@ public:
      become available.  NULL if we aren't interested in any
      symbols.  */
   virtual void look_up_symbols ();
+
+  /* Send an interrupt request to the inferior process,
+     however is appropriate.  */
+  virtual void request_interrupt () = 0;
 };
 
 extern process_stratum_target *the_target;
diff --git a/gdbserver/win32-low.c b/gdbserver/win32-low.c
index 8baf4a32e4f..b2ed7f8b01e 100644
--- a/gdbserver/win32-low.c
+++ b/gdbserver/win32-low.c
@@ -1685,8 +1685,8 @@ win32_process_target::write_memory (CORE_ADDR memaddr,
 }
 
 /* Send an interrupt request to the inferior process. */
-static void
-win32_request_interrupt (void)
+void
+win32_process_target::request_interrupt ()
 {
   winapi_DebugBreakProcess DebugBreakProcess;
   winapi_GenerateConsoleCtrlEvent GenerateConsoleCtrlEvent;
@@ -1828,7 +1828,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  win32_request_interrupt,
   NULL, /* read_auxv */
   win32_supports_z_point_type,
   win32_insert_point,
diff --git a/gdbserver/win32-low.h b/gdbserver/win32-low.h
index 27ba64ce916..078ae7255f3 100644
--- a/gdbserver/win32-low.h
+++ b/gdbserver/win32-low.h
@@ -135,6 +135,8 @@ public:
 
   int write_memory (CORE_ADDR memaddr, const unsigned char *myaddr,
 		    int len) override;
+
+  void request_interrupt () override;
 };
 
 /* Retrieve the context for this thread, if not already retrieved.  */