diff --git a/gdbserver/linux-low.c b/gdbserver/linux-low.c
index 4a621acccdf..ae10d5a2282 100644
--- a/gdbserver/linux-low.c
+++ b/gdbserver/linux-low.c
@@ -1681,9 +1681,10 @@ linux_process_target::join (int pid)
   } while (ret != -1 || errno != ECHILD);
 }
 
-/* Return nonzero if the given thread is still alive.  */
-static int
-linux_thread_alive (ptid_t ptid)
+/* Return true if the given thread is still alive.  */
+
+bool
+linux_process_target::thread_alive (ptid_t ptid)
 {
   struct lwp_info *lwp = find_lwp_pid (ptid);
 
@@ -4004,7 +4005,7 @@ wait_for_sigstop (void)
 				       &wstat, __WALL);
   gdb_assert (ret == -1);
 
-  if (saved_thread == NULL || linux_thread_alive (saved_tid))
+  if (saved_thread == NULL || mythread_alive (saved_tid))
     current_thread = saved_thread;
   else
     {
@@ -7358,7 +7359,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_thread_alive,
   linux_resume,
   linux_wait,
   linux_fetch_registers,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index 37ee4b45a41..f3bb7826a68 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -283,6 +283,8 @@ public:
   void mourn (process_info *proc) override;
 
   void join (int pid) override;
+
+  bool thread_alive (ptid_t pid) override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.c b/gdbserver/lynx-low.c
index e4694f4d053..99ef605f27d 100644
--- a/gdbserver/lynx-low.c
+++ b/gdbserver/lynx-low.c
@@ -570,8 +570,8 @@ lynx_process_target::join (int pid)
 
 /* Implement the thread_alive target_ops method.  */
 
-static int
-lynx_thread_alive (ptid_t ptid)
+bool
+lynx_process_target::thread_alive (ptid_t ptid)
 {
   /* The list of threads is updated at the end of each wait, so it
      should be up to date.  No need to re-fetch it.  */
@@ -726,7 +726,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  lynx_thread_alive,
   lynx_resume,
   lynx_wait,
   lynx_fetch_registers,
diff --git a/gdbserver/lynx-low.h b/gdbserver/lynx-low.h
index a0d5099918e..aa5d4b20505 100644
--- a/gdbserver/lynx-low.h
+++ b/gdbserver/lynx-low.h
@@ -69,6 +69,8 @@ public:
   void mourn (process_info *proc) override;
 
   void join (int pid) override;
+
+  bool thread_alive (ptid_t pid) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/nto-low.c b/gdbserver/nto-low.c
index 9fc66088109..bd2ee687147 100644
--- a/gdbserver/nto-low.c
+++ b/gdbserver/nto-low.c
@@ -431,10 +431,10 @@ nto_process_target::join (int pid)
 
 /* Check if the given thread is alive.  
 
-   Return 1 if alive, 0 otherwise.  */
+   Return true if alive, false otherwise.  */
 
-static int
-nto_thread_alive (ptid_t ptid)
+bool
+nto_process_target::thread_alive (ptid_t ptid)
 {
   int res;
 
@@ -941,7 +941,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  nto_thread_alive,
   nto_resume,
   nto_wait,
   nto_fetch_registers,
diff --git a/gdbserver/nto-low.h b/gdbserver/nto-low.h
index dc321c14405..056186e0071 100644
--- a/gdbserver/nto-low.h
+++ b/gdbserver/nto-low.h
@@ -59,6 +59,8 @@ public:
   void mourn (process_info *proc) override;
 
   void join (int pid) override;
+
+  bool thread_alive (ptid_t pid) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/target.h b/gdbserver/target.h
index a32667ee6d9..e2bdddcb137 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,10 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Return 1 iff the thread with process ID PID is alive.  */
-
-  int (*thread_alive) (ptid_t pid);
-
   /* Resume the inferior process.  */
 
   void (*resume) (struct thread_resume *resume_info, size_t n);
@@ -483,6 +479,9 @@ public:
 
   /* Wait for process PID to exit.  */
   virtual void join (int pid) = 0;
+
+  /* Return true iff the thread with process ID PID is alive.  */
+  virtual bool thread_alive (ptid_t pid) = 0;
 };
 
 extern process_stratum_target *the_target;
@@ -523,7 +522,7 @@ int kill_inferior (process_info *proc);
   the_target->pt->detach (proc)
 
 #define mythread_alive(pid) \
-  (*the_target->thread_alive) (pid)
+  the_target->pt->thread_alive (pid)
 
 #define fetch_inferior_registers(regcache, regno)	\
   (*the_target->fetch_registers) (regcache, regno)
diff --git a/gdbserver/win32-low.c b/gdbserver/win32-low.c
index af80ba77023..adf0dc4d902 100644
--- a/gdbserver/win32-low.c
+++ b/gdbserver/win32-low.c
@@ -886,9 +886,9 @@ win32_process_target::join (int pid)
     }
 }
 
-/* Return 1 iff the thread with thread ID TID is alive.  */
-static int
-win32_thread_alive (ptid_t ptid)
+/* Return true iff the thread with thread ID TID is alive.  */
+bool
+win32_process_target::thread_alive (ptid_t ptid)
 {
   /* Our thread list is reliable; don't bother to poll target
      threads.  */
@@ -1828,7 +1828,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  win32_thread_alive,
   win32_resume,
   win32_wait,
   win32_fetch_inferior_registers,
diff --git a/gdbserver/win32-low.h b/gdbserver/win32-low.h
index 0204f2fee35..e73569b07b3 100644
--- a/gdbserver/win32-low.h
+++ b/gdbserver/win32-low.h
@@ -118,6 +118,8 @@ public:
   void mourn (process_info *proc) override;
 
   void join (int pid) override;
+
+  bool thread_alive (ptid_t pid) override;
 };
 
 /* Retrieve the context for this thread, if not already retrieved.  */