diff --git a/gdbserver/linux-low.c b/gdbserver/linux-low.c
index 636a4933841..9d02e96f6f0 100644
--- a/gdbserver/linux-low.c
+++ b/gdbserver/linux-low.c
@@ -6010,22 +6010,22 @@ linux_process_target::supports_stopped_by_sw_breakpoint ()
   return USE_SIGTRAP_SIGINFO;
 }
 
-/* Implement the to_stopped_by_hw_breakpoint target_ops
+/* Implement the stopped_by_hw_breakpoint target_ops
    method.  */
 
-static int
-linux_stopped_by_hw_breakpoint (void)
+bool
+linux_process_target::stopped_by_hw_breakpoint ()
 {
   struct lwp_info *lwp = get_thread_lwp (current_thread);
 
   return (lwp->stop_reason == TARGET_STOPPED_BY_HW_BREAKPOINT);
 }
 
-/* Implement the to_supports_stopped_by_hw_breakpoint target_ops
+/* Implement the supports_stopped_by_hw_breakpoint target_ops
    method.  */
 
-static int
-linux_supports_stopped_by_hw_breakpoint (void)
+bool
+linux_process_target::supports_stopped_by_hw_breakpoint ()
 {
   return USE_SIGTRAP_SIGINFO;
 }
@@ -7376,8 +7376,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_stopped_by_hw_breakpoint,
-  linux_supports_stopped_by_hw_breakpoint,
   linux_supports_hardware_single_step,
   linux_stopped_by_watchpoint,
   linux_stopped_data_address,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index 4ef1a3f4cf9..41f99591b3e 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -325,6 +325,10 @@ public:
   bool stopped_by_sw_breakpoint () override;
 
   bool supports_stopped_by_sw_breakpoint () override;
+
+  bool stopped_by_hw_breakpoint () override;
+
+  bool supports_stopped_by_hw_breakpoint () override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.c b/gdbserver/lynx-low.c
index 91ff7a1dd0b..7f074445f37 100644
--- a/gdbserver/lynx-low.c
+++ b/gdbserver/lynx-low.c
@@ -729,8 +729,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  NULL,  /* stopped_by_hw_breakpoint */
-  NULL,  /* supports_stopped_by_hw_breakpoint */
   target_can_do_hardware_single_step,
   NULL,  /* stopped_by_watchpoint */
   NULL,  /* stopped_data_address */
diff --git a/gdbserver/nto-low.c b/gdbserver/nto-low.c
index 8a412868829..b7adc82da69 100644
--- a/gdbserver/nto-low.c
+++ b/gdbserver/nto-low.c
@@ -950,8 +950,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  NULL, /* stopped_by_hw_breakpoint */
-  NULL, /* supports_stopped_by_hw_breakpoint */
   target_can_do_hardware_single_step,
   nto_stopped_by_watchpoint,
   nto_stopped_data_address,
diff --git a/gdbserver/target.c b/gdbserver/target.c
index 70630db6d84..f7dc0f4d658 100644
--- a/gdbserver/target.c
+++ b/gdbserver/target.c
@@ -459,3 +459,15 @@ process_target::supports_stopped_by_sw_breakpoint ()
 {
   return false;
 }
+
+bool
+process_target::stopped_by_hw_breakpoint ()
+{
+  return false;
+}
+
+bool
+process_target::supports_stopped_by_hw_breakpoint ()
+{
+  return false;
+}
diff --git a/gdbserver/target.h b/gdbserver/target.h
index 3be0ff9cdb8..aae0e3afd24 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,13 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Returns 1 if the target stopped for a hardware breakpoint.  */
-  int (*stopped_by_hw_breakpoint) (void);
-
-  /* Returns true if the target knows whether a trap was caused by a
-     HW breakpoint triggering.  */
-  int (*supports_stopped_by_hw_breakpoint) (void);
-
   /* Returns true if the target can do hardware single step.  */
   int (*supports_hardware_single_step) (void);
 
@@ -476,6 +469,13 @@ public:
   /* Returns true if the target knows whether a trap was caused by a
      SW breakpoint triggering.  */
   virtual bool supports_stopped_by_sw_breakpoint ();
+
+  /* Returns true if the target stopped for a hardware breakpoint.  */
+  virtual bool stopped_by_hw_breakpoint ();
+
+  /* Returns true if the target knows whether a trap was caused by a
+     HW breakpoint triggering.  */
+  virtual bool supports_stopped_by_hw_breakpoint ();
 };
 
 extern process_stratum_target *the_target;
@@ -665,16 +665,14 @@ target_read_btrace_conf (struct btrace_target_info *tinfo,
   the_target->pt->stopped_by_sw_breakpoint ()
 
 #define target_supports_stopped_by_hw_breakpoint() \
-  (the_target->supports_stopped_by_hw_breakpoint ? \
-   (*the_target->supports_stopped_by_hw_breakpoint) () : 0)
+  the_target->pt->supports_stopped_by_hw_breakpoint ()
 
 #define target_supports_hardware_single_step() \
   (the_target->supports_hardware_single_step ? \
    (*the_target->supports_hardware_single_step) () : 0)
 
 #define target_stopped_by_hw_breakpoint() \
-  (the_target->stopped_by_hw_breakpoint ? \
-   (*the_target->stopped_by_hw_breakpoint) () : 0)
+  the_target->pt->stopped_by_hw_breakpoint ()
 
 #define target_breakpoint_kind_from_pc(pcptr) \
   (the_target->breakpoint_kind_from_pc \
diff --git a/gdbserver/win32-low.c b/gdbserver/win32-low.c
index 31be06c0af2..9e8a3801099 100644
--- a/gdbserver/win32-low.c
+++ b/gdbserver/win32-low.c
@@ -1828,8 +1828,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  NULL, /* stopped_by_hw_breakpoint */
-  NULL, /* supports_stopped_by_hw_breakpoint */
   target_can_do_hardware_single_step,
   win32_stopped_by_watchpoint,
   win32_stopped_data_address,