diff --git a/gdbserver/linux-low.c b/gdbserver/linux-low.c
index fb2f79c2204..4a621acccdf 100644
--- a/gdbserver/linux-low.c
+++ b/gdbserver/linux-low.c
@@ -1669,8 +1669,8 @@ linux_process_target::mourn (process_info *process)
   remove_process (process);
 }
 
-static void
-linux_join (int pid)
+void
+linux_process_target::join (int pid)
 {
   int status, ret;
 
@@ -7358,7 +7358,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-  linux_join,
   linux_thread_alive,
   linux_resume,
   linux_wait,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index 4b9d6ce65b6..37ee4b45a41 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -281,6 +281,8 @@ public:
   int detach (process_info *proc) override;
 
   void mourn (process_info *proc) override;
+
+  void join (int pid) override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.c b/gdbserver/lynx-low.c
index 55721ac87b2..e4694f4d053 100644
--- a/gdbserver/lynx-low.c
+++ b/gdbserver/lynx-low.c
@@ -561,8 +561,8 @@ lynx_process_target::mourn (struct process_info *proc)
 
 /* Implement the join target_ops method.  */
 
-static void
-lynx_join (int pid)
+void
+lynx_process_target::join (int pid)
 {
   /* The PTRACE_DETACH is sufficient to detach from the process.
      So no need to do anything extra.  */
@@ -726,7 +726,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  lynx_join,
   lynx_thread_alive,
   lynx_resume,
   lynx_wait,
diff --git a/gdbserver/lynx-low.h b/gdbserver/lynx-low.h
index b290922e4b4..a0d5099918e 100644
--- a/gdbserver/lynx-low.h
+++ b/gdbserver/lynx-low.h
@@ -67,6 +67,8 @@ public:
   int detach (process_info *proc) override;
 
   void mourn (process_info *proc) override;
+
+  void join (int pid) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/nto-low.c b/gdbserver/nto-low.c
index 09ae60219a6..9fc66088109 100644
--- a/gdbserver/nto-low.c
+++ b/gdbserver/nto-low.c
@@ -423,6 +423,12 @@ nto_process_target::mourn (struct process_info *process)
   remove_process (process);
 }
 
+void
+nto_process_target::join (int pid)
+{
+  error (_("nto target does not implement the join op"));
+}
+
 /* Check if the given thread is alive.  
 
    Return 1 if alive, 0 otherwise.  */
@@ -935,7 +941,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  NULL, /* nto_join */
   nto_thread_alive,
   nto_resume,
   nto_wait,
diff --git a/gdbserver/nto-low.h b/gdbserver/nto-low.h
index fd675811753..dc321c14405 100644
--- a/gdbserver/nto-low.h
+++ b/gdbserver/nto-low.h
@@ -57,6 +57,8 @@ public:
   int detach (process_info *proc) override;
 
   void mourn (process_info *proc) override;
+
+  void join (int pid) override;
 };
 
 /* The inferior's target description.  This is a global because the
diff --git a/gdbserver/target.h b/gdbserver/target.h
index 4c0a98b3ed0..a32667ee6d9 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,10 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* Wait for process PID to exit.  */
-
-  void (*join) (int pid);
-
   /* Return 1 iff the thread with process ID PID is alive.  */
 
   int (*thread_alive) (ptid_t pid);
@@ -484,6 +480,9 @@ public:
 
   /* The inferior process has died.  Do what is right.  */
   virtual void mourn (process_info *proc) = 0;
+
+  /* Wait for process PID to exit.  */
+  virtual void join (int pid) = 0;
 };
 
 extern process_stratum_target *the_target;
@@ -533,7 +532,7 @@ int kill_inferior (process_info *proc);
   (*the_target->store_registers) (regcache, regno)
 
 #define join_inferior(pid) \
-  (*the_target->join) (pid)
+  the_target->pt->join (pid)
 
 #define target_supports_non_stop() \
   (the_target->supports_non_stop ? (*the_target->supports_non_stop ) () : 0)
diff --git a/gdbserver/win32-low.c b/gdbserver/win32-low.c
index c7ba29567d4..af80ba77023 100644
--- a/gdbserver/win32-low.c
+++ b/gdbserver/win32-low.c
@@ -875,8 +875,8 @@ win32_process_target::mourn (struct process_info *process)
 
 /* Implementation of target_ops::join.  */
 
-static void
-win32_join (int pid)
+void
+win32_process_target::join (int pid)
 {
   HANDLE h = OpenProcess (PROCESS_ALL_ACCESS, FALSE, pid);
   if (h != NULL)
@@ -1828,7 +1828,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  win32_join,
   win32_thread_alive,
   win32_resume,
   win32_wait,
diff --git a/gdbserver/win32-low.h b/gdbserver/win32-low.h
index 4ab92dbdae8..0204f2fee35 100644
--- a/gdbserver/win32-low.h
+++ b/gdbserver/win32-low.h
@@ -116,6 +116,8 @@ public:
   int detach (process_info *proc) override;
 
   void mourn (process_info *proc) override;
+
+  void join (int pid) override;
 };
 
 /* Retrieve the context for this thread, if not already retrieved.  */