diff --git a/gdbserver/linux-low.c b/gdbserver/linux-low.c
index 4ec396af289..ef68a8a89e2 100644
--- a/gdbserver/linux-low.c
+++ b/gdbserver/linux-low.c
@@ -6387,6 +6387,16 @@ linux_process_target::handle_new_gdb_connection ()
     });
 }
 
+int
+linux_process_target::handle_monitor_command (char *mon)
+{
+#ifdef USE_THREAD_DB
+  return thread_db_handle_monitor_command (mon);
+#else
+  return 0;
+#endif
+}
+
 static int
 linux_supports_disable_randomization (void)
 {
@@ -7418,11 +7428,6 @@ linux_get_hwcap2 (int wordsize)
 static linux_process_target the_linux_target;
 
 static process_stratum_target linux_target_ops = {
-#ifdef USE_THREAD_DB
-  thread_db_handle_monitor_command,
-#else
-  NULL,
-#endif
   linux_common_core_of_thread,
   linux_read_loadmap,
   linux_process_qsupported,
diff --git a/gdbserver/linux-low.h b/gdbserver/linux-low.h
index 0881155cc5e..c37db38749b 100644
--- a/gdbserver/linux-low.h
+++ b/gdbserver/linux-low.h
@@ -376,6 +376,8 @@ public:
   bool supports_exec_events () override;
 
   void handle_new_gdb_connection () override;
+
+  int handle_monitor_command (char *mon) override;
 };
 
 #define get_thread_lwp(thr) ((struct lwp_info *) (thread_target_data (thr)))
diff --git a/gdbserver/lynx-low.c b/gdbserver/lynx-low.c
index 7bfd71c5321..5db9d2f154d 100644
--- a/gdbserver/lynx-low.c
+++ b/gdbserver/lynx-low.c
@@ -735,7 +735,6 @@ static lynx_process_target the_lynx_target;
 /* The LynxOS target_ops vector.  */
 
 static process_stratum_target lynx_target_ops = {
-  NULL,  /* handle_monitor_command */
   NULL,  /* core_of_thread */
   NULL,  /* read_loadmap */
   NULL,  /* process_qsupported */
diff --git a/gdbserver/nto-low.c b/gdbserver/nto-low.c
index 8ff8063dfba..880e8ccecd1 100644
--- a/gdbserver/nto-low.c
+++ b/gdbserver/nto-low.c
@@ -947,7 +947,6 @@ nto_sw_breakpoint_from_kind (int kind, int *size)
 static nto_process_target the_nto_target;
 
 static process_stratum_target nto_target_ops = {
-  NULL, /* handle_monitor_command */
   NULL, /* core_of_thread */
   NULL, /* read_loadmap */
   NULL, /* process_qsupported */
diff --git a/gdbserver/server.c b/gdbserver/server.c
index f427e7706fb..f9817881d77 100644
--- a/gdbserver/server.c
+++ b/gdbserver/server.c
@@ -2577,8 +2577,7 @@ handle_query (char *own_buf, int packet_len, int *new_packet_len_p)
 
       write_ok (own_buf);
 
-      if (the_target->handle_monitor_command == NULL
-	  || (*the_target->handle_monitor_command) (mon) == 0)
+      if (the_target->pt->handle_monitor_command (mon) == 0)
 	/* Default processing.  */
 	handle_monitor_command (mon, own_buf);
 
diff --git a/gdbserver/target.c b/gdbserver/target.c
index 3416a3f449f..74cd90a48a4 100644
--- a/gdbserver/target.c
+++ b/gdbserver/target.c
@@ -577,3 +577,9 @@ process_target::handle_new_gdb_connection ()
 {
   /* Nop.  */
 }
+
+int
+process_target::handle_monitor_command (char *mon)
+{
+  return 0;
+}
diff --git a/gdbserver/target.h b/gdbserver/target.h
index 1138ed2e440..7d7e371cf32 100644
--- a/gdbserver/target.h
+++ b/gdbserver/target.h
@@ -70,10 +70,6 @@ class process_target;
    shared code.  */
 struct process_stratum_target
 {
-  /* If not NULL, target-specific routine to process monitor command.
-     Returns 1 if handled, or 0 to perform default processing.  */
-  int (*handle_monitor_command) (char *);
-
   /* Returns the core given a thread, or -1 if not known.  */
   int (*core_of_thread) (ptid_t);
 
@@ -486,6 +482,10 @@ public:
 
   /* Allows target to re-initialize connection-specific settings.  */
   virtual void handle_new_gdb_connection ();
+
+  /* The target-specific routine to process monitor command.
+     Returns 1 if handled, or 0 to perform default processing.  */
+  virtual int handle_monitor_command (char *mon);
 };
 
 extern process_stratum_target *the_target;
diff --git a/gdbserver/win32-low.c b/gdbserver/win32-low.c
index bee5cbbf643..ed847447e40 100644
--- a/gdbserver/win32-low.c
+++ b/gdbserver/win32-low.c
@@ -1842,7 +1842,6 @@ win32_sw_breakpoint_from_kind (int kind, int *size)
 static win32_process_target the_win32_target;
 
 static process_stratum_target win32_target_ops = {
-  NULL, /* handle_monitor_command */
   NULL, /* core_of_thread */
   NULL, /* read_loadmap */
   NULL, /* process_qsupported */